//-----------------------------------------------------------------------------------------------------------------
// @Rabbitoreg RiseWise v2.1
// Exploring supplemental functionality for Articulate Rise. This is not for production! Not tested. 
// Version 1.1: Fixed next lesson links at the bottom of the page. 
// Version 2.1: Articulate has changed the way do links. Now both lesson and list appear in the URL. Adjusted to that change.
// Version 2.1: No longer numbers are indicating lessons, now it's text IDs. See below.
//
//------------------------------------------------------------------------------------------------------------------

// Global variables for support
var gLastHref=""; // last known href in the browser
var gCurrentLesson=0; // Current lesson location. 
var gCurrentBranch=0;
var gRollOver = false;	
var gHashArray = new Array();
var counter=0;
var gBranches = new Array();
var splitid;
//-------------------------------------------------------------------- ADD YOUR DATA HERE--------------------------------------------------
// Replace these lines with your data:
setBranchData ("26KNGgZaHmB81kJEeYOwW1i9SKEOpkPz","2vtuOGXdRLwtbKXeH-zzZ2nPD8gTNxuY,6xAFT-P6kX1Ncdt4oF-x8Ms8tpdfWqFe,kiWmhLSNiKYuzgT-h5GF6kWv_sP-Q6SF",1,"ad0IRY7q2PpOd33ur9_QiypAp_HXcKJg","0");
setBranchData ("ad0IRY7q2PpOd33ur9_QiypAp_HXcKJg","VrPPS-1hTDeFa4rDxMRixve-leLEHq6B,nZ5X-YnWN7atCCprLusRS3EpAqzOMea6,XhQjxkn2jXgWmL0skoCGzwF1hhXSgEEZ",0,"7LEQHoR1oJxuNpgBvUKpkFmD7U_aMExj","26KNGgZaHmB81kJEeYOwW1i9SKEOpkPz");


/*
Articulate has changed how they're handling links. In this new version, you'll have to work with long IDs and not simple numbers.
setBranchData Arguments:
1. Lesson ID (you can see this by hovering over the lesson in the published Rise course: #/lessons/26KNGgZaHmB81kJEeYOwW1i9SKEOpkPz The id is "26KNGgZaHmB81kJEeYOwW1i9SKEOpkPz")
2. Branches (lessons to hide that belongs to this scenario. Use comma to seperate them: "2vtuOGXdRLwtbKXeH-zzZ2nPD8gTNxuY,6xAFT-P6kX1Ncdt4oF-x8Ms8tpdfWqFe,kiWmhLSNiKYuzgT-h5GF6kWv_sP-Q6SF")
3. Status. This is the only number you pass: 0 - Not visible, 1 - Visible You need to show the first one at least.
4. Next Branch ID. If you do multiple fake branching, add the next ID here. 
5. Previous Branch ID. If this is the first branch, set it to "0" since there's no previous branching. Otherwise, set it to the previous branch ID.
*/

//---------------------------------------------------------------------DATA END------------------------------------------------------------------



function setBranchData(branchID,branches,branchStatus,nextBranch,prevBranch)
{
var cnt = gBranches.length;	
gBranches[cnt]= new Array();
gBranches[cnt][0]=branchID;
gBranches[cnt][1]=branches.split(",");
gBranches[cnt][2]=branchStatus;
gBranches[cnt][3]=nextBranch;
gBranches[cnt][4]=prevBranch;
gHashArray[branchID]=cnt;

}

function findBranchArrayId(id)
{
	var arr=getBranch(id);
	if (arr.length>0)
	{
		return arr[0];
	}
	else
	{
		return -1;
	}
	
}

function getBranch(item)
{
	var result = Array();
	var mix = Array();
	
for( var i = 0; i<gBranches.length; i++ ) {
    mix = gBranches[i][1];
	
	if( mix.indexOf(item) >-1 ) {
        result[0] = i;
		result[1] = mix.indexOf(item);
		result[2] = gBranches[i][2];
		result[3] = gBranches[i][3];
		result[4] = gBranches[i][4];
        break;
    }
}

return result;
}

function getScenario(item)
{
	var result = Array();
	var mix = Array();
	
for( var i = 0; i<gBranches.length; i++ ) {
    mix = gBranches[i][0];
	
	if( mix.indexOf(item) >-1 ) {
        result[0] = i;
		result[1] = mix.indexOf(item);
		result[2] = gBranches[i][2];
		result[3] = gBranches[i][3];
	result[4] = gBranches[i][4];
        
		break;
    }
}

return result;
}

function setScenarioStatus(id,sstatus)
{
	gBranches[id][2]=ssatus;
}

function isListOrLesson(href)
{

if (href)
{
var hash=href;
}
else
{
// Saving hash part of the address.	
var hash=location.hash;

}	

	
	var ret = "";
	if (hash.indexOf("/lessons/") > -1)
	{
		ret = "/lessons/"
	}
	else if ((hash.indexOf("/list/") > -1))
	{
       ret = "/list/";  
	}	

return (ret);

}

//--------------------------------------------------ON LOAD---------------------------------------------------------------------
$( document ).ready(function() {
	
	

// Saving hash part of the address.	
var hash=location.hash;

// creating the core address
var core;
var splitid;



splitid = isListOrLesson();
//if the page has the "list" or "lesson" we're on the lesson pages
//we're trying to load the course from a direct link to a lesson
// let's return to the main page

if (splitid!=="")
{
	core = hash.split("#");

	
	
	var lnum= location.hash.split(splitid);

    gCurrentLesson = lnum[1].split("?")[0];



	//var myid = getLesson($(this).attr('href'));
	
	var mycheck = getBranch(gCurrentLesson);
	
	if (mycheck.length>0)
	{	
	jQuery(this).hide();
	}
	
	var mycheck = getScenario(gCurrentLesson);
	
	if ((mycheck.length>0) && (mycheck[2]==0))
	{	
	jQuery(this).hide();
	}
	
	
	location.href=core[0];

$('.lesson-lists__item a').each(function(){
	
	//alert($(this).attr('href'));
	var myid = getLesson($(this).attr('href'));
	var mycheck = getBranch(myid);
	
	if (mycheck.length>0)
	{	
	jQuery(this).hide();
	
	//jQuery('.next-lesson__link a').attr("href","#/list/"+mycheck[3]);
	}
	
	var mycheck = getScenario(myid);
	
	if (mycheck.length>0)
	{
    if (mycheck[2]==0)
 	{
		jQuery(this).hide();
	
		//jQuery('.next-lesson__link a').attr("href","#/list/"+mycheck[3]);
	}
	else
	{
	jQuery(this).show();
	
	//jQuery('.next-lesson__link a').attr("href","#/list/"+mycheck[3]);
	}	
	
	}
	
})

$('.next-lesson__link').each(function(){
	
	
	var myid = getLesson($(this).attr('href'));
	
	var mycheck = getBranch(myid);
	
	
	
	if (mycheck.length>0)
	{	
	jQuery(this).hide();
	
	//jQuery('.next-lesson__link').replaceWith("");
	
	
	}
	
	
	
	var mycheck = getScenario(myid);
	
	if (mycheck.length>0)
	{
    if (mycheck[2]==0)
 	{
			
		jQuery(this).attr("href","#"+splitid+mycheck[3]);
	}
	else
	{
	jQuery(this).show();

	}	
	
	}	
	
	
})


$('.overview-list__item a').each(function(){
	
	
	var myid = getLesson($(this).attr('href'));
	
	var mycheck = getBranch(myid);
	
	if (mycheck.length>0)
	{	
		jQuery(this).parent().hide();
	}
})


}

// if not, we're on the front page. we're good. let's save the current location as the last known good location.
else
{
	
gLastHref=location.href;

$('.overview-list__item a').each(function(){
	
	//alert($(this).attr('href'));
	var myid = getLesson($(this).attr('href'));

	var mycheck = getBranch(myid);

	
	if (mycheck.length>0)
	{	
jQuery(this).parent().hide();
	}

	
	
	var mycheck = getScenario(myid);
	
	if (mycheck.length>0)
	{
    if (mycheck[2]==0)
 	{
		jQuery(this).parent().hide();
	
		jQuery('.next-lesson__link a').attr("href","#"+splitid+mycheck[3]);
	}
	else
	{
	jQuery(this).parent().show();
	
	jQuery('.next-lesson__link a').attr("href","#"+splitid+mycheck[3]);
	}	
	
	}	
	
	})

}
	
});


function getLesson(href)
{

var splitid = isListOrLesson(href);	
if (href!==undefined)
{
var str=href.split(splitid);

if (str.length>1)
{ return str[1];}
else
{
	return 0;
}
}
else
{
	return 0;
}	

	

}




function checkAccess(myid,mode)
{
	var mycheck;
	
	if (mode=="branch")
	{
	mycheck = getBranch(myid);
	}
	else{
		
	mycheck = getScenario(myid);	
	
	}
	var action=0;
	
	if (mycheck[4]=="0")
	{
		
		action= 3;
	}
	else
	{
		
		
		if (mycheck[4]!==undefined)
		{

		if (gBranches[gHashArray[mycheck[4]]][2]==2)
		{
			
			action= 2;
		}
		else
		{
			action =0;;
		}
		}
	}
	
	if ((mode=="branch") && (mycheck.length>0))
	{
	
	switch (action) 
	{
		case 3:
		gBranches[0][2]=2;
		break;
		
		case 2:
		gBranches[mycheck[0]][2]=2;
		
		break;
		case 1:
		gBranches[mycheck[0]][2]=1;
		
		break;
		default:
		
		gBranches[mycheck[0]][2]=0;
		
		break;
	}
	}
return action;	
}
//--------------------------------------------------------------ON PAGE REF CHANGE

$(window).on('hashchange', function(e){

splitid = isListOrLesson();	


$('.lesson-lists__item a').each(function(){
	
	
	var myid = getLesson($(this).attr('href'));
	
	var mycheck = getBranch(myid);
	
	if (mycheck.length>0)
	{	
	jQuery(this).hide();
	
	//jQuery('.next-lesson__link').replaceWith("");
	
	
	}
	
	
	
	var mycheck = getScenario(myid);
	
	if (mycheck.length>0)
	{
    if (mycheck[2]==0)
 	{
		jQuery(this).hide();
	
	//	jQuery('.next-lesson__link a').attr("href","#/list/"+mycheck[3]);
	}
	else
	{
	jQuery(this).show();
	
//	jQuery('.next-lesson__link a').attr("href","#/list/"+mycheck[3]);
	}	
	
	}	
	
	
})


$('.next-lesson__link').each(function(){
	
		var myid = getLesson($(this).attr('href'));
	
	var mycheck = getBranch(myid);
	
	
	
	if (mycheck.length>0)
	{	
	jQuery(this).hide();
	
	//jQuery('.next-lesson__link').replaceWith("");
	
	
	}
	
	
	
	var mycheck = getScenario(myid);
	
	if (mycheck.length>0)
	{
    if (mycheck[2]==0)
 	{
			
		jQuery(this).attr("href","#"+splitid+mycheck[3]);
	}
	else
	{
	jQuery(this).show();

	}	
	
	}	
	
	
})



$('.overview-list__link').each(function(){
	
	
	
	var myid = getLesson($(this).attr('href'));
	
	var mycheck = getBranch(myid);
	
	
	
	if (mycheck.length>0)
	{	
	jQuery(this).parent().hide();
	
	}
	
	var mycheck = getScenario(myid);
	
	if (mycheck.length>0)
	{
    if (mycheck[2]==0)
 	{
		jQuery(this).parent().hide();
	
		jQuery('.next-lesson__link a').attr("href","#"+splitid+mycheck[3]);
	}
	else
	{
	jQuery(this).parent().show();
	
	jQuery('.next-lesson__link a').attr("href","#"+splitid+mycheck[3]);
	}	
	
	}	
	
	
	
})

cnt = 0; 
var hash = location.hash.replace( /^#/, '' );

hideSeek(); 
 
 
 
if (splitid!=="")
{
	
var lnum= location.hash.split(splitid);
var lesson = lnum[1].split("?")[0];

var mystatus = getScenario(lesson);
checkAccess(lesson,"branch");


if (mystatus.length>0)
{
	if (checkAccess(lesson,"scenario")>0)
	{
		gCurrentLesson=lesson;
		gLastHref=location.href;	
	}
	else
	{
		
		location.href=gLastHref;
	}
	
/*	
  if (mystatus[4]=="0")
  {
	  
	  // Previous scenario is complete or this is the first one.
	  gBranches[mystatus[0]][2]=1;
	  
  }
  else
  {
	  
	  if (mystatus[2]==2)
	  {
	  gBranches[mystatus[0]][2]=1;
	  }
		else
		{
			location.href=gLastHref;
		}	
	  
  }
  */
}
else
{
gCurrentLesson=lesson;
gLastHref=location.href;	
}	

}



 });
 
String.prototype.replaceAll = function(str1, str2, ignore) 
{
    return this.replace(new RegExp(str1.replace(/([\/\,\!\\\^\$\{\}\[\]\(\)\.\*\+\?\|\<\>\-\&])/g,"\\$&"),(ignore?"gi":"g")),(typeof(str2)=="string")?str2.replace(/\$/g,"$$$$"):str2);
} 
 


function hideSeek()
{
var codeSplit;
var codeCond;
var regExp;
var regExpMatches;
//$("h2 div").prepend("_zomagixCond::gPoints>100::_");	
$("p").each(function(){
        
		regExp = /_zomagixCond::(.)*::_/g;
		matches = regExp.exec($(this).text());
		 
		if (matches)
		{
			
		codeSplit = matches[0].split("::");	
		$(this).attr("zsoltcond",codeSplit[1]);
		$(this).text($(this).text().replace(matches[0],""));
		$(this).addClass("zsoltcond");
		}

		
		
    });

hideShow();
}

function hideShow()
{
	$('.zsoltcond').each(function(){
		
	
		if (eval($(this).attr("zsoltcond")))
		{
			$(this).show();
		}
		else
		{
			
			$(this).hide();
		}
	})	
}



